unit sky_toast1;
{get realsky image, settings }
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DdeMan, Menus, ComCtrls, Buttons,jpeg,pngimage,
  URLMon,   {For downloading files}
  math;
type
  Tmainwindow = class(TForm)
    MainMenu1: TMainMenu;
    Help: TMenuItem;
    About1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    LoadBMP1: TMenuItem;
    LoadFITSfile1: TMenuItem;
    SaveasBMP1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    File1: TMenuItem;
    ool1: TMenuItem;
    Reverse_toast_projection1: TMenuItem;
    Maketoastprojection2: TMenuItem;
    Doublesize1: TMenuItem;
    Halfsize1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    AddmultipleFITStoEquirectangularprojection1: TMenuItem;
    AddESOmilkyway1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure LoadFITSfile1Click(Sender: TObject);
    procedure SaveasBMP1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LoadBMP1Click(Sender: TObject);
    procedure toast_projection1Click(Sender: TObject);
    procedure Reverse_toast_projection1Click(Sender: TObject);
    procedure Doublesize1Click(Sender: TObject);
    procedure Halfsize1Click(Sender: TObject);
    procedure AddmultipleFITStoEquirectangularprojection1Click(Sender: TObject);
    procedure DownloadDSS2Click(Sender: TObject);
    procedure AddESOmilkyway1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mainwindow  : Tmainwindow;
  filename2   : string;
  filename_short  : string;
  makebit8    : boolean; {make an additional 8 bit fits?}
const
   initialized:boolean=false;
   oldangle: double=0;

procedure de_toast(x1, y1, size : integer; var lon,lat :double); {de-TOAST x,y coordinates to lat, lon. The origin (0,0) is top left of TOAST projection, size:=height or witdh}
{inverse Tessellated Octahedral Adaptive Subdivision Transform (TOAST) projection}


implementation

uses sky_toast2 ;

{$R *.DFM}


procedure Tmainwindow.About1Click(Sender: TObject);
begin
  messagebox(mainwindow.handle,
          'This program converts and Equirectangular projection to a TOAST (Tessellated Octahedral Adaptive Subdivision Transform) projection and reverse. In addition it can add mulitple FITS files to the projection. The projection can be used in the HNSKY program.'+
  #10+#13+
  #10+#13+'Send a message if you like this free program. Feel free to distribute !'+
  #10+#13+
  #10+#13+'Version 0.0 dated 2016-3-28.'+
  #10+#13+'by Han Kleijn. Webpage: www.hnsky.org'

 ,'About Sky_TOASTER',MB_OK);
end;



procedure Tmainwindow.Exit1Click(Sender: TObject);
begin
  application.terminate;
end;


procedure Tmainwindow.LoadFITSfile1Click(Sender: TObject);
begin
  opendialog1.Filter := 'Flexible image transport system files (*.fit*)|*.fit*';
  if opendialog1.execute then
  begin
    realsky.release;

    {create realsky form}
    realsky:=Trealsky.Create(self); {by purpose, in project option not loaded automatic}
    {special trick to get image1 during creation big enough. As soon it is created, size can not be adjusted. Then only option is the delete form and create it again}
    realsky.visible:=true;
    filename2:=opendialog1.filename;
    loadfits(filename2);

    realsky.HorzScrollBar.Range := realsky.Image1.Picture.Width;
    realsky.VertScrollBar.Range := realsky.Image1.Picture.Height;

  end;
end;
procedure de_toast(x1, y1, size : integer; var lon,lat :double); {de-TOAST x,y coordinates to lat, lon. The origin (0,0) is top left of TOAST projection, size:=height or witdh}
{ inverse Tessellated Octahedral Adaptive Subdivision Transform (TOAST) projection}
var
 quad,  quadrant, ax,ay, hemisphere: integer;
 x,y :double;
begin
  {www.hnsky.org}
  {use eight-fold symmetry of TOAST projection}
  {for x, y range is 0,0 at top left corner}
  {For x, y the left top is 0,0. x is horizontal, y is vertical}
  {calculate x,y}
  x:=-1+ x1/(0.5*size) ;{make range -1..+1, zero at centre, y is positive up, x is positive to the right}
  y:=+1- y1/(0.5*size);{make range -1..+1, zero at centre}

    if( x < 0 ) then  {left part}
    begin
      if( y > 0 ) then {left top quartor}
      begin
      if( y -x < 1 ) then
        begin {left top quartor, northern hemisphere}
          x:=-x;{move origin}
          lat:=(1-y-x)*pi/2;
          lon:=0.5*pi*(1-x/(y+x+0.000000000000001));
          lon:=pi+lon;{bring in range}
        end
        else
        begin {left top quartor, southern hemisphere}
          x:=1+x;{move origin}
          y:=1-y;{move origin}
          lat:=(1-y-x)*pi/2;
          lon:=0.5*pi*(1-x/(y+x+0.000000000000001));
          lat:=-lat; {bring in range}
          lon:=1.5*pi-lon;{bring in range}
        end;
     end
     else
     begin {bottom left quarter}
       if( -y-x < 1)  then
       begin {northern hemisphere}
          x:=-x;{move origin}
          y:=-y;{move origin}
          lat:=(1-y-x)*pi/2;
          lon:=0.5*pi*(1-x/(y+x+0.000000000000001));
          lon:=pi-lon;{bring in range}
       end
       else
       begin {southern hemisphere}
          x:=1+x;{move origin}
          y:=1+y;{move origin}
          lat:=(1-y-x)*pi/2;
          lon:=0.5*pi*(1-x/(y+x+0.000000000000001));
          lat:=-lat; {bring in range}
          lon:=0.5*pi+lon;{bring in range}
       end;
     end;
   end

   else  {x>0, right part}
   begin
     if( y > 0 ) then {right top quarter}
     begin
       if( y + x <1 ) then
       begin  {right top quarter, Northern hemisphere}
          lat:=(1-y-x)*pi/2;
         lon:=0.5*pi*(1-x/(y+x+0.000000000000001));
         lon:=2*pi-lon;{bring in range}
       end
       else
       begin   {right top quarter, Southern hemisphere}
         x:=1-x;{move origin}
         y:=1-y;{move origin}
          lat:=(1-y-x)*pi/2;
         lon:=0.5*pi*(1-x/(y+x+0.000000000000001));
         lat:=-lat; {bring in range}
         lon:=1.5*pi+lon;{bring in range}
       end;
     end {right top part}
     else
     begin {y<0, right bottom quarter}
       if( -y +x <1 ) then
       begin  {right bottom quarter, Northern hemisphere}
         y:=-y;{move origin}
          lat:=(1-y-x)*pi/2;
         lon:=0.5*pi*(1-x/(y+x+0.000000000000001));
       end
       else
       begin {right bottom quarter, Southern hemisphere}
         x:=1-x;{move origin to south pole and reverse direction x}
         y:=y+1;{move origin}
          lat:=(1-y-x)*pi/2;
         lon:=0.5*pi*(1-x/ (y+x+0.000000000000001));
         lat:=-lat; {bring in range}
         lon:=0.5*pi-lon;{bring in range}
       end;
     end;
   end;

   {keep within range to prevent errors}
   if lon>pi*2 then lon:=pi*2;
   if lon<0 then lon:=0;
   if lat>pi/2 then lat:=pi/2;
   if lat<-pi/2 then lat:=-pi/2;
end;


procedure toast(lon,lat :double; var x, y : double); {TOAST lat, lon,  to x,y in range -1..+1}
{ Tessellated Octahedral Adaptive Subdivision Transform (TOAST) projection}

var
   factor1, factor2: integer;
   dummy :double;
begin
  if lon<pi then
  begin
    factor1:=+0;
    factor2:=+1;
  end
  else
  begin
    factor1:=-2;
    factor2:=-1;
  end;

  x:=((1-(abs(lat)*2/PI))*(2/PI)*((factor1+0.5)*PI()-factor2*(lon)));
  y:=factor2*(1-abs(lat)*2/PI -abs(x));

  if lat<0 then {swap x, y and mirror for four triangles with latitude below 0}
  begin
    if lon<0.5*pi  then begin   dummy:=x;   x:=-y+1;  y:=-dummy+1; end
    else
    if lon<1.0*pi  then begin   dummy:=x;   x:=+y-1;  y:=+dummy+1;  end
    else
    if lon<1.5*pi  then begin   dummy:=x;   x:=-y-1;  y:=-dummy-1;  end
    else
                        begin   dummy:=x;   x:=+y+1;  y:=+dummy-1;  end;

  end;

 end;



procedure Tmainwindow.Reverse_toast_projection1Click(Sender: TObject);
var
  BMP   : TBitmap;
  i, j,new_height,k  : integer;
  xp,yp,zp,ra7,dec7 :double;
  xp1,yp1,zp1,r :double;
  dummy :tcolor;
  OldCursor : TCursor;
begin
  OldCursor := Screen.Cursor;
  Screen.Cursor:= crHourGlass;

  BMP := TBitmap.Create;
  try
    height2:=realsky.image1.picture.height-1;
    wide2:=realsky.image1.picture.width-1;

    new_height:=round(height2*1);{fiddle factor to smooth}
//    new_height:=round(height2*0.7);{fiddle factor to smooth}
    bmp.height:=new_height+1;
    bmp.width:= 2*new_height+1;{make square}

    bmp.Canvas.Brush.Color := clblack;
    bmp.Canvas.FillRect(Rect(0,0,bmp.height-1, bmp.width-1));

    for i:=round(0) to round(wide2) do
    begin
    //   realsky.Caption:={inttostr(j)+'   '+}inttostr(i);

      for J:=0 to round(height2) do
      begin
        dummy:=getpixel(realsky.image1.canvas.handle,i,j); {read from image}
          de_toast( i, j,height2,ra7,dec7);
        for k:=0 to round(abs(1.3/cos(dec7*0.9999))) do {double the pixels close to the poles}
          setpixel(bmp.canvas.handle,round(new_height*2*(1-ra7/(2*pi)))+ (k) , round((1+dec7/(0.5*pi))* new_height/2), dummy);    {dump calculated pixels to BMP}
      end;
    end;

    {special trick to get image1 during creation big enough. As soon it is created, size can not be adjusted. Then only option is the delete form and create it again}

    realsky.release;
    realsky:=Trealsky.Create(self); {by purpose, in project option not loaded automatic}
    realsky.visible:=true;

    realsky.Image1.Picture.Graphic := BMP ;    {dump BMP to image}

    height2:=bmp.height-1;
    wide2:=bmp.width-1;

  finally
    BMP.Free
  end;
  realsky.Width:=wide2;
  realsky.height:=height2+30;
  Screen.Cursor:= OldCursor;
end;

procedure Tmainwindow.toast_projection1Click(Sender: TObject);
var
  BMP   : TBitmap;
  i, j,new_height  : integer;
  xp,yp,zp,x7,y7 :double;
  xp1,yp1,zp1 :double;
  dummy : integer; //tcolor;
  OldCursor : TCursor;
begin
  OldCursor := Screen.Cursor;
  Screen.Cursor:= crHourGlass;

  BMP := TBitmap.Create;
  try
    height2:=realsky.image1.picture.height;
    wide2:=realsky.image1.picture.width;

    new_height:=round(height2*1);{fiddle factor to smooth}
    bmp.height:=new_height;
    bmp.width:= new_height;{make square}
    bmp.Canvas.Brush.Color := clblack;
    bmp.Canvas.FillRect(Rect(0,0,new_Height, new_height));


    for i:=1 to wide2-1 do
    begin
      for J:=1 to height2-1 do
      begin
        toast( pi*2*((wide2-1)-i)/(wide2-1){ra}, pi*(0.5*(height2-1)-j)/(height2-1) {dec},x7,y7);
        dummy:=getpixel(realsky.image1.canvas.handle,i,j); {read from image}

        setpixel(bmp.canvas.handle,round( (new_height-1)/2+x7* (new_height-1)/2),round( (new_height-1)/2+y7*(new_height-1)/2), dummy);    {dump calculated pixels to BMP}
      end;
    end;
    {special trick to get image1 during creation big enough. As soon it is created, size can not be adjusted. Then only option is the delete form and create it again}
    realsky.release;
    realsky:=Trealsky.Create(self); {by purpose, in project option not loaded automatic}
    realsky.visible:=true;
    realsky.Image1.Picture.Graphic := BMP ;    {dump BMP to image}
    height2:=bmp.height-1;
    wide2:=bmp.width-1;
  finally
    BMP.Free;
  end;
  realsky.Width:=wide2;
  realsky.height:=height2+30;
  Screen.Cursor:= OldCursor;

end;
procedure Tmainwindow.Doublesize1Click(Sender: TObject);
var
  intermediate,result2: TBitmap;
begin
  intermediate:= TBitmap.Create;
  result2:= TBitmap.Create;
  try
    intermediate.assign(realsky.image1.picture);
    result2.Height:=round(2*realsky.image1.picture.height);
    result2.Width:=round(2*realsky.image1.picture.width);
    result2.Canvas.StretchDraw(Rect(0,0,result2.Width,result2.Height),intermediate);
    realsky.image1.picture.Graphic:=result2;
  finally
    intermediate.Free;
    result2.Free;
  end;{try}
  wide2:=realsky.Image1.Picture.Width;
  height2:=realsky.Image1.Picture.Height;
  realsky.Width:=wide2;
  realsky.height:=height2+30;
end;
function DownloadFile(SourceFile, DestFile: string): Boolean;{2013, download files from internet}
var
   OldCursor : TCursor;
begin
  OldCursor := Screen.Cursor;
  Screen.Cursor:= crHourGlass;
  try
    Result := UrlDownloadToFile(nil, PWChar(SourceFile), PWChar(DestFile), 0, nil) = 0;
  except
    Result := False;
  end;
  Screen.Cursor:= oldcursor;
end;

procedure Tmainwindow.DownloadDSS2Click(Sender: TObject);
const
   skyview: string='http://skyview.gsfc.nasa.gov/cgi-bin/pskcall?return=fits&Survey=DSS2R&sampler=Lanczos';
var
   internetlink,ras,decs: string;
   ra8,dec8: double;
   ra_counter,dec_counter,dec_stop,ra_stop,step_size :integer;

begin
  FormatSettings.decimalseparator:='.'; {for floattostr and strtofloat !! in german and german systems}

  dec_counter:=-25;{degrees}
  dec_stop:=-15;{degrees}
  step_size:=1; {degrees}
  repeat {dec loop}
    ra_counter:=round(17*15); {degrees}
    ra_stop:=round(18*15);{degrees}
    repeat {ra loop}
    begin
       ras:=floattostrf(ra_counter,ffFixed,6,4);
       decs:=floattostrf(dec_counter,ffFixed,6,4);
       internetlink:=skyview+'&VCOORD='+ras+','+decs+
               '&PIXELX='+inttostr(60)+
               '&PIXELY='+inttostr(60)+
               '&SFACTR=1.0'{size_image indegrees};{not limitations but skyview stops at around 140 degrees}

    mainwindow.caption:='Downloading: '+ras+'_'+decs;
    if DownloadFile(internetlink, 'DSS2R_'+ras+'_'+decs+'.fit') then
    begin
      beep;
    end
    else
       messagebox(mainwindow.handle, pwchar('Eror while downloading: ' + internetlink) ,pwchar('Error'),MB_OK);
    end;
    inc(ra_counter,step_size);
    until ra_counter>=ra_stop;
    inc(dec_counter,step_size);
  until dec_counter>=dec_stop;
   mainwindow.caption:='Ready';
end;

procedure Tmainwindow.Halfsize1Click(Sender: TObject);
var
  intermediate,result2: TBitmap;
begin
  intermediate:= TBitmap.Create;
  result2:= TBitmap.Create;
  try
    intermediate.assign(realsky.image1.picture);
    result2.Height:=round(0.5*realsky.image1.picture.height);
    result2.Width:=round(0.5*realsky.image1.picture.width);
    result2.Canvas.StretchDraw(Rect(0,0,result2.Width,result2.Height),intermediate);
    realsky.image1.picture.Graphic:=result2;
  finally
    intermediate.Free;
    result2.Free;
  end;{try}
  wide2:=realsky.Image1.Picture.Width;
  height2:=realsky.Image1.Picture.Height;
  realsky.Width:=wide2;
  realsky.height:=height2+30;
end;


procedure Tmainwindow.SaveasBMP1Click(Sender: TObject);{save image to bitmap file}
var filename3:ansistring;
    PNG: TPNGObject;
    JPG: TJPEGImage;
begin
  filename3:=ChangeFileExt(FileName2,'.png');
  savedialog1.filename:=filename3;
  savedialog1.Filter := 'PNG, BMP, JPG files  (*.png,*.bmp,*.jpg)|*.png;*.bmp;*.jpg';
  if savedialog1.execute then
  begin
    if pos('.PNG',uppercase(savedialog1.filename))>0 then
    begin
      PNG := TPNGObject.Create;
      try
        PNG.Assign(realsky.image1.Picture.Graphic);    //Convert data into png
        PNG.SaveToFile(savedialog1.filename);
      finally
       PNG.Free;
      end;
    end
    else
    if pos('.JPG',uppercase(savedialog1.filename))>0 then
    begin
      JPG := TJPEGImage.Create;
      try
        JPG.Assign(realsky.image1.Picture.Graphic);    //Convert data into png
        JPG.SaveToFile(savedialog1.filename);
      finally
       JPG.Free;
      end;
    end
    else
    begin {bitmap}
      realsky.image1.picture.SaveToFile(savedialog1.filename);
    end;
  end;

end;

procedure Tmainwindow.FormPaint(Sender: TObject);
begin
   initialized:=true;
end;

procedure Tmainwindow.FormShow(Sender: TObject);
begin
  if paramcount=1 then   {file as first parameter}
  begin
    filename2:=paramstr(1);
    realsky.visible:=true;
    loadfits(filename2);
  end;
end;

procedure Convert_to_BMP;
var
 BMP : TBitmap;
begin
  BMP := TBitmap.Create;
  try
    BMP.assign(realsky.Image1.Picture.Graphic);
    realsky.Image1.Picture.Graphic := BMP
  finally
    BMP.Free
  end;
end;

procedure Tmainwindow.LoadBMP1Click(Sender: TObject);
begin
  opendialog1.Filter := 'BMP, PNG, JPEG (*.bmp,*.png,*.jpg)|*.bmp;*.png;*.jpg';
  if opendialog1.execute then
  begin
    realsky.image1.picture.LoadFromFile(opendialog1.filename);
    if (realsky.image1.Picture.Graphic is TBitmap)=false then
      convert_to_bmp;

    realsky.caption:=ExtractFileName(opendialog1.filename);

    wide2:=realsky.Image1.Picture.Width;
    height2:=realsky.Image1.Picture.Height;

    realsky.clientwidth :=realsky.Image1.Picture.Width; {important use clientheight instead height}
    realsky.clientHeight :=realsky.Image1.Picture.Height+realsky.statusbar1.height;
    realsky.visible:=true;
    filename2:=opendialog1.filename;
    filename_short:=ExtractFileName(filename2);
    realsky.caption:=filename_short;

    nrbits:=-8;{indication BMP}

    {new september 2002}
    realsky.HorzScrollBar.Range := realsky.Image1.Picture.Width;
    realsky.VertScrollBar.Range := realsky.Image1.Picture.Height;
  end;
end;





procedure GAL_EQU(l,b: double;var ra,dec: double);{galactic to equatorial coordinates}
const
  {North_galactic pole (J2000)}
  pole_ra : double = 192.8595*pi/180;
  pole_dec: double =  27.1283*pi/180;
  posangle: double =  32.9319*pi/180;

// Converting between galactic to equatorial coordinates
// The galactic north pole is at RA = 12:51.4, Dec = +27:07 (2000.0),
// the galactic center at RA = 17:45.6, Dec = -28:56 (2000.0).
// The inclination of the galactic equator to the celestial equator is thus 62.9.
// The intersection, or node line, of the two equators is at
// RA = 282.25, Dec = 0:00 (2000.0), and at l = 33, b=0.
// The transformation between the equatorial and galactic systems consisted of:
// 1. a rotation around the celestial polar axis by 282.25,
// so that the reference zero longitude matches the node
// 2. a rotation around the node by 62.9
// 3. a rotation around the galactic polar axis by 33
// so that the zero longitude meridian matches the galactic center.

// North galactic pole (B1950)
// pole_ra = radians(192.25)
// pole_dec = radians(27.4)
// posangle = radians(123.0-90.0)
var
  sin_b, cos_b, sin_pole_dec, cos_pole_dec :extended;
begin
  sincos(b,sin_b, cos_b);
  sincos(pole_dec,sin_pole_dec, cos_pole_dec);
  ra  := arctan2( (cos_b*cos(l-posangle)), (sin_b*cos_pole_dec - cos_b*sin_pole_dec*sin(l-posangle)) ) + pole_ra;
  dec := arcsin( cos_b*cos_pole_dec*sin(l-posangle) + sin_b*sin_pole_dec );

//  ra  := arctan2( (cos(b)*cos(l-posangle)), (sin(b)*cos(pole_dec) - cos(b)*sin(pole_dec)*sin(l-posangle)) ) + pole_ra;
//  dec := arcsin( cos(b)*cos(pole_dec)*sin(l-posangle) + sin(b)*sin(pole_dec) );
end;




procedure Tmainwindow.AddESOmilkyway1Click(Sender: TObject);
var
   sum_of_valuesR,sum_of_valuesG,sum_of_valuesB,  nr_of_values  : array of array of integer;{{dynamic 2 dimensions array}
   PNG: TPNGObject;
   i,j,k  : integer;
   ra2,dec2,gal_long,gal_lat, sub_sampleX, sub_sampleY  : double;
   raX, decx      :integer;
   col            :tcolor;

begin
  PNG := TPNGObject.Create;
  try
    png.LoadFromFile('eso0932a.png');


    SetLength(sum_of_valuesR, png.height,png.Width);{set size dynamic array}
    SetLength(sum_of_valuesG, png.height,png.Width);{set size dynamic array}
    SetLength(sum_of_valuesB, png.height,png.Width);{set size dynamic array}
    SetLength(nr_of_values, png.height, png.width);

    for i:=0 to png.Height-1 do {range rect projection. DEC, Y}
    begin
      for j:=0 to png.width-1 do  {RA, x}
      begin {empthy values}

        sum_of_valuesR[i,j]:=0;
        sum_of_valuesG[i,j]:=0;
        sum_of_valuesB[i,j]:=0;
        nr_of_values[i,j]:=0;
      end;
    end;


    for i:=0 to png.height-1 do {Y, 3000}
    begin
      realsky.Caption:=inttostr(i);
      for j:=0 to png.width-1 do {X, 6000}
      begin

        col:=getpixel(png.Canvas.handle,j,i);
        //GetBValue(x)+getGvalue(x)+getRvalue(x))


        for k:=1 to 4 do {sub sampling, to prevent black christmas trees near poles}
        begin
            {new WCS pixel to RA, DEC}
            case k of 1: begin sub_sampleX:=-0.25; sub_sampleY:=-0.25; end;
                      2: begin sub_sampleX:=-0.25; sub_sampleY:=+0.25; end;
                      3: begin sub_sampleX:=+0.25; sub_sampleY:=-0.25; end;
                      4: begin sub_sampleX:=+0.25; sub_sampleY:=+0.25; end;
                    end; {case}


        gal_long:=2*pi*((png.width-1)-(j+sub_sampleY))/(png.width-1)-pi;
        gal_lat:= pi/2- pi*((i+sub_sampleX)/(png.height-1));

        {apply measured correction!!!!!!!!!!}
        gal_long:=gal_long+ 3*pi/180;
        gal_lat:=gal_lat -2*(pi/180)*cos(gal_long);
        {end of correction}

        GAL_EQU(gal_long,gal_lat, ra2,dec2);
        if ra2>2*pi then ra2:=ra2-2*pi;
        if ra2<0    then ra2:=ra2+2*pi;
        rax:=round(wide2*(1-ra2/(2*pi))   ); {equatorial coordinates in pixels}        {!!! take 1/4 to not have holes in the plot}
        decX:=round(height2*(0.5-dec2/pi));

        {sum up values}
        sum_of_valuesR[decx,rax]:=sum_of_valuesR[decx,rax]+getRvalue(col);
        sum_of_valuesG[decx,rax]:=sum_of_valuesG[decx,rax]+getGvalue(col);
        sum_of_valuesB[decx,rax]:=sum_of_valuesB[decx,rax]+getBvalue(col);
        nr_of_values[decx,rax]:=nr_of_values[decx,rax]+1;

        end;

      //  setpixel(realsky.image1.canvas.handle,rax,decx,col {rgb(128,200,129)});
      end;
    end;

  for i:=0 to png.height-1 do {range rect}
  begin
    for j:=0 to png.width-1 do
    begin {average value to pixel}
      if nr_of_values[i,j]<>0 then
      begin

        col:=rgb(  ($FF and round(sum_of_valuesR[i,j]/nr_of_values[i,j])   ),    {FF against too high or low values}
                   ($FF and round(sum_of_valuesG[i,j]/nr_of_values[i,j])   ),
                   ($FF and round(sum_of_valuesB[i,j]/nr_of_values[i,j])   )  );

        try setpixel(realsky.image1.canvas.handle,j,i,col);except;end;
      end;
    end;
  end;
  nr_of_values := nil;{remove dynamic array from memory}
  sum_of_valuesB:=nil;{remove dynamic array from memory}
  sum_of_valuesG:=nil;{remove dynamic array from memory}
  sum_of_valuesR:=nil;{remove dynamic array from memory}

  finally
  png.Free;
  end;

  invalidaterect(realsky.handle,nil,false);{paint again}
end;

procedure Tmainwindow.AddmultipleFITStoEquirectangularprojection1Click(Sender: TObject);
var
  I: integer;
  Save_Cursor:TCursor;
begin
  OpenDialog1.Title := 'Select multiple FITS files to add to equirectangular projection';
  OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist,ofHideReadOnly];
  opendialog1.Filter := 'Flexible image transport system files (*.fit*)|*.fit*';
  if opendialog1.execute then
  begin
    Save_Cursor := Screen.Cursor;
    Screen.Cursor := crHourglass;    { Show hourglass cursor }
    try { Do some lengthy operation }
      with OpenDialog1.Files do
      for I := 0 to Count - 1 do
      begin
        if OpenDialog1.Files.strings[I]<>'' then
        begin
          plotfits(OpenDialog1.Files.strings[I]);
        end;
      end;
    finally
      Screen.Cursor := Save_Cursor;  { Always restore to normal }
    end;
  end; {end conversion}
end;


end.
